Hi Folks,
i need a special query with additional fields in select statement and a HAVING.
for example:
$query = "SELECT ort, plz, (
 ".$radius." * SQRT) * 
 cos(".$rad_b.") * (sin(RADIANS) *
 sin(".$rad_l.") + cos(RADIANS) * 
 cos(".$rad_l.")) - sin(RADIANS) * sin(".$rad_b.")))) AS Distance 
 FROM plz Having Distance <= ".$umkreis." 
 ORDER BY Distance
";

as far as i know i can add special fields with:
$this->queryBuilder()->add(); by the queryBuilder of \TYPO3\FLOW3\Persistence\Doctrine\Query.
But the query builder is protected and there is no getter for it.
It is a good or a bad idea to add public function getQueryBuilder into the Query Class to enable a usage like:
$this->query->getQueryBuilder->add('select'...)?

if anybody could tell me how to do the query above, please tell me.

thanks a lot!
carsten

History
#1 - 2011-11-19 14:21 - Carsten Bleicker

if queryBuilder is accessible the whole power of doctrine could be used by default in repositories.
for example:
$this->query->getQueryBuilder()->join()
or $this->query->getQueryBuilder()->having().

but in case i make it public and build the guery as above the CountWalker throws exceptions because some vars missing in
$this->_getQueryComponents()
if something is in select wich has nothing to do with properties of the model.

i dont know exactly. but is doctrine configuration also available somewhere?
if it isnt it would be also usefull to do to register some functions for Doctrine\ORM\Query\AST\Functions.
for example:
$query->getEntityManager()->getConfiguration()->addCustomNumericFunction('ACOS','BLEICKER\Social\Persistence\Doctrine\ORM\Query\AST\Fu
ctions\AcosFunction');

#2 - 2011-11-22 12:45 - Karsten Dambekalns
- Target version deleted (1.0.1)

#3 - 2012-03-07 17:14 - Karsten Dambekalns
- Tracker changed from Bug to Feature

#4 - 2014-02-21 10:03 - Franz Kugelmann

Just stumbled upon a snippet for such needs from Bastian:
https://gist.github.com/bwaidelich/5433673

#5 - 2015-03-05 14:31 - Karsten Dambekalns
- Status changed from New to Resolved
- % Done changed from 0 to 100

This has been solved as a side effect of FLOW-110, Doctrine\Query now has getQueryBuilder()
